#! /usr/bin/python

# To change this template, choose Tools | Templates
# and open the template in the editor.

__author__="Lester Garcia"
__date__ ="$08-Mar-2011 19:39:20$"

from openravepy import *
from numpy import *
#import sys
#script_path="Vislab/OR6_Scripts/manual_control/src"
#sys.path.append(script_path)

def run_demo():
    def generate_paths():
        """
        Returns databases of paths

        (env_paths, robot_paths, object_paths) = generate_paths()
        """
        #--Generate env PATHs Database--#
        env_paths = {}
        env_paths["empty"] = "Vislab/OR4_Envs/Empty.env.xml"
        env_paths["Vislab"] = "Vislab/OR4_Envs/.env.xml"
        env_paths["Piso7"] = "Vislab/OR4_Envs/ISR_Piso7.env.xml"
        #--Generate robot PATHs Database--#
        robot_paths = {}
        robot_paths["Baltazar"] = "Vislab/OR3_Robots/Baltazar.robot.xml"
        robot_paths["Baltazar_segway"] = "Vislab/OR3_Robots/Baltazar_segway.robot.xml"
        robot_paths["Shadow_Arm"] = "Vislab/OR3_Robots/Shadow_Arm.robot.xml"
        #--Generate object PATHs Database--#
        object_paths = {}
        object_paths["cuboid"] = "Vislab/OR1_Objects/blue_cuboid.kinbody.xml"
        object_paths["mug"] = "Vislab/OR1_Objects/blue_mug.kinbody.xml"
        object_paths["cylinder"] = "Vislab/OR1_Objects/green_cylinder.kinbody.xml"
        object_paths["ball"] = "Vislab/OR1_Objects/red_ball.kinbody.xml"
        object_paths["table"] = "Vislab/OR1_Objects/table.kinbody.xml"

        print "\nThe following Environments are Defined in env_paths.:\n"
        for key in env_paths:
            print key + " = " + str(env_paths.get(key))
        print "\nThe following Robots are Defined in robot_paths.:\n"
        for key in robot_paths:
            print key + " = " + str(robot_paths.get(key))
        print "\nThe following Objectss are Defined in object_paths.:\n"
        for key in object_paths:
            print key + " = " + str(object_paths.get(key))
        return (env_paths, robot_paths, object_paths)
    def trans_matrix(x,y,z):
        """
        Returns a Translation Matrix

        T = trans_matrix(x,y,z)
        """
        T = [(1.,0.,0.,x),(0.,1.,0.,y),(0.,0.,1.,z),(0.,0.,0.,1.)]
        return T
    #--START RUNNING--#
    #--------------------------------------------------------#
    (env_paths, robot_paths, object_paths) = generate_paths()

    #--Create Objects (this does not mean to load them to the scene)
    env = Environment() # empty environment
    cylinder = env.ReadKinBodyXMLFile(object_paths.get("cylinder"))
    table = env.ReadKinBodyXMLFile(object_paths.get("table"))
    baltazar = env.ReadRobotXMLFile(robot_paths.get("Baltazar"))

    #--Set Places for Objects--#
    cylinder.SetTransform(trans_matrix(0,0,0.6))
    table.SetTransform(trans_matrix(0,0,0))
    baltazar.SetTransform(trans_matrix(-0.3,0,0))

    #--Load objects to the Scene Environment Simulation--#
    env.SetViewer("qtcoin")
    raw_input("Loading object...")
    env.AddKinBody(table)
    raw_input("Loading object...")
    env.AddKinBody(cylinder)
    raw_input("Loading object...")
    env.AddRobot(baltazar)
    print "Objects have been loaded to the Scene"
    num_objects = str(len(env.GetBodies()))
    print "there are " + num_objects + " in the Scene..."

    #--UnLoad objects from the Scene--#
    raw_input("Enter will remove")
    env.Remove(baltazar)
    raw_input("Enter will remove")
    env.Remove(cylinder)
    raw_input("Enter will remove")
    env.Remove(table)
    raw_input("Enter to Finish")
    env.Destroy()


if __name__ == "__main__":
    raw_input("Enter to initialize the Basic Load - Unload DEMO")
    run()